#!/usr/bin/python
# -*- coding:utf-8 -*-

import urllib, sys, string

global apply_urllib

# you can set this flag as False to enhance efficiency
apply_urllib = True

class ServerNotRespondedError ( Exception ):
    pass

if apply_urllib:
    # pretend FireFox
    urllib.URLopener.version = 'Mozilla/5.0 (Macintosh; U; PPC Mac OS X Mach-O; ja-JPM; rv:1.7.8) Gecko/20050511 Firefox/1.0.4'
    pass

def __n2( num ):
    return ( "0%d" % num )[ -2: ]

def __get_home():
    import tempfile, re, os, os.path
    file_temp = tempfile.mktemp()
    env = os.system( "/usr/bin/env > %s" % file_temp )
    path_home = "~/"
    for line in open( file_temp ).readlines():
        m = re.match( "HOME\\s*=\\s*(.+)", line.strip() )
        if m:
            path_home = m.group( 1 )
            if os.path.islink( path_home ):
                path_home = os.path.realpath( path_home )
                pass
            break
        pass
    os.unlink( file_temp )
    return path_home

def __make_dir( dirname ):
    import os.path
    if os.path.exists( dirname ) == False:
        os.system( "mkdir -p \"%s\"" % dirname )
        pass
    pass

def __remove_older_files( directory, threshold ):
    import os.path, os
    for ( path, dirs, fns ) in os.walk( directory ):
        for fn in fns:
            filepath = "%s/%s" % ( path, fn )
            num = fn.split( "." )[ 0 ]
            if num < threshold:
                os.unlink( filepath )
                pass
            pass
        pass
    pass

class __WeatherChartRetriever:
    def __init__( self, item, url, directory ):
        import os, os.path
        self.item = item
        self.url = url
        self.url_base = url[ 0: url.rfind( '/' ) ]
        self.directory = directory
        if os.path.islink( directory ):
            self.directory = os.path.realpath( directory )
            pass
        # create directory
        if os.path.exists( directory ) == False:
            try:
                os.system( "mkdir -p \"%s\"" % directory )
            except Exception, e:
                raise
            pass
        pass

    def __get_image_filename( self, offset = 0 ):
        import time
        tm = time.localtime( time.time() + offset )
        name = "%d" % tm[0] + ("0%d" % tm[ 1 ] )[-2:] + ("0%d" % tm[ 2 ])[-2:] + ("0%d" % tm[ 3 ])[-2:]
        return "%s/%s.jpg" % ( self.directory, name )
        pass

    def __get_image_path( self ):
        import tempfile, os, string, re, os.path
        filename_tmp = None
        stream = None
        if apply_urllib:
            stream = urllib.urlopen( self.url )
        else:
            filename_tmp = tempfile.mktemp()
            command = "/usr/bin/curl %s -o %s -s" % ( self.url, filename_tmp )
            os.system( command )
            if os.path.exists( filename_tmp ) == False:
                raise ServerNotRespondedError( "Network Error" )
            stream = open ( filename_tmp )
            pass

        r_img = re.compile( "<img\\s", re.I )
        r_src = re.compile( "\\bsrc\\s*=\\s*\"(images/[^\"]+)", re.I )
        r_size = re.compile( "width\\s*=\\s*\"?(\\d+)", re.I )
        path_url = None
        line = stream.readline()
        while line and line != "":
            m_img = r_img.search( line )
            if m_img:
                m_src = r_src.search( line )
                if m_src:
                    m_size = r_size.search( line, m_img.start() )
                    if m_size:
                        width = string.atoi( m_size.group( 1 ) )
                        if width > 200:
                            path_url = m_src.group( 1 )
                            break
                        pass
                    pass
                pass
            line = stream.readline()
            pass
        if filename_tmp:
            os.unlink( filename_tmp )
            pass
        stream.close()
        return path_url
        

    def retrieve( self ):
        import os, os.path, sys
        filename_image = self.__get_image_filename()
        # already loaded ?
        if os.path.exists( filename_image ):
            return 'file:///' + filename_image

        import tempfile, string, re
        try:
            path_url = self.__get_image_path()
        except:
            sys.stderr.write( "cannot get image path\n" )
            raise
        
        stream       = None
        filename_tmp = None
        if path_url == None: return None
        
        filename_tmp = tempfile.mktemp( '.jpg', 'weatherchart_' + self.item )
        url_image = self.url_base + '/' + path_url
        if apply_urllib:
            stream = urllib.urlopen( url_image )
            open( filename_tmp, 'w' ).write( stream.read() )
        else:
            command = "/usr/bin/curl \"%s\" -o \"%s\" -s" % ( ( self.url_base + '/' + path_url ),  filename_tmp )
            os.system( command )
            pass
        if os.path.exists( filename_tmp ) == False:
            raise ServerNotRespondedError( "Network Error" )
        
        filename_prev  = self.__get_image_filename( offset = - 3600 )

        # weather chart graph is revised after every 3 hr
        # then chart must be checked graphs until before 3hr
        if self.item == 'chart':
            if os.path.exists( filename_prev ) == False:
                filenaem_prev = self.__get_image_filename( offset = - 7200 )
                if os.path.exists( filename_prev ) == False:
                    filenaem_prev = self.__get_image_filename( offset = - 10800 )
                    pass
                pass
            pass

        if os.path.exists( filename_prev ):
            if open( filename_prev ).read( 1024 ) == open( filename_tmp ).read( 1024 ):
                os.unlink( filename_tmp )
                return "file://" + filename_prev
            pass
        try:
            os.system( 'mv "%s" "%s"' % ( filename_tmp, filename_image ) )
            #os.rename( filename_tmp, filename_image )
        except Exception, e:
            import sys
            sys.stderr.write( str( e ) )
            sys.stderr.write( "\n" )
	    raise
        return url_image
    ## return "file://" + filename_image

    def list_images( self ):
        import os, os.path
        images = []
        for ( path, dirs, fns ) in os.walk( self.directory ):
            for fn in fns:
                images.append( "file://" + self.directory + "/" + fn )
                pass
            pass
        images.sort( lambda x, y: - ( x > y ) )
        return images
    pass

if __name__ == "__main__":
    import os, sys
    global __dir_home
    __dir_home  = __get_home()
    __dir_image = "%s/Library/JPWeatherChart/" % ( __dir_home )
    if os.path.islink( __dir_image ):
        __dir_image = os.path.realpath( __dir_image )
        pass

    generator = "snowy.weather.winter.stomy.cloudy"
    __base = generator[ 10 ] + generator[ -11 ] + generator[ 9 ] + "p:" + "//" + generator[ 3 ] + generator[ 7: 13 ]\
           + generator[ -7 ] + generator[ 8 ] \
           + generator[ -12 ] + generator[ 8 ] + generator[ 10 ] + generator[ -18 ] + generator[ 20 ] + generator[ -6 ] \
           + generator[ 2 ] + generator[ 24 ]
    __remove_threshold = None

    # remove or retain cache
    if sys.argv.count( '-retain' ) > 0:
        remove_cache = False
    else:
        remove_cache = True
	retain_period = 7
        import time
	i = 0
	while i < len( sys.argv ):
	    if sys.argv[ i ] == '-cacheperiod':
		try:
		    retain_period = string.atoi( sys.argv[ i + 1 ] )
		    pass
		except:
		    raise
		    pass
		pass
	    i += 1
	    pass
        tm = time.localtime( time.time() - 3600 * 24 * retain_period )
        __remove_threshold = "%d%s%s%s" % ( tm[ 0 ], __n2( tm[ 1 ] ), __n2( tm[ 2 ] ), __n2( tm[ 3 ] ) )
        pass

    # list all images for animation
    if sys.argv.count( '-list' ) > 0:
        list_mode = True
    else:
        list_mode = False
        pass

    for arg in sys.argv[ 1: ]:
        path_target = None
        if arg[ 0 ] == '-': continue
        if arg == 'chart':
            path_target = "/wxct/index.html"
        elif arg == 'gms':
            path_target = "/gms/index.html"
        elif arg == 'rain':
            path_target = "/amedas/rain.html"
            pass
        elif arg == 'wind':
            path_target = "/amedas/wind.html"
            pass
        elif arg == 'temp':
            path_target = "/amedas/index.html"
            pass
        if path_target == None: continue
        obj = __WeatherChartRetriever( arg, __base + path_target,
                                       __dir_image + arg )
        if remove_cache:
            __remove_older_files( __dir_image + arg, __remove_threshold )
            pass

        if list_mode:
            uris = obj.list_images()
            if len( uris ) > 0:
                output = ""
                base_uri = uris[ 0 ][ 0: uris[ 0 ].rfind( '/' ) + 1 ]
                output += base_uri + "\n"
                #print base_uri
                for uri in uris:
                    start = uri.rfind( '/' ) + 1
                    end   = uri.rfind( '.' )
                    num = uri[ start : end ]
                    if len( output ) + len( num ) > 4095:
                        break
                    output += num + "\n"
                    pass
                print output
                pass
            pass
        else:
            try:
                print obj.retrieve()
                pass
            except ServerNotRespondedError, e:
                sys.stderr.write( "サーバーが応答しません" );
		pass
	    except IOError, ioe:
		sys.stderr.write( "ネットワークに接続できません" );
		pass
            except:
                raise
                sys.stderr.write( "Network Error" );
            pass
        pass
    pass
